#include <stdio.h>

#include <global.h>
#include <misc.h>
#include <ostime.h>

/* forward declarations */
void GetTDString( TIMEDATE * ptdModified, char * szTimedate );


STATUS LNPUBLIC NotesMain (int argc, char *argv[])
{
	STATUS		nError = NOERROR;
	char		szStartTime[MAXALPHATIMEDATE+1], szEndTime[MAXALPHATIMEDATE+1];
	char		szStartConv[MAXALPHATIMEDATE+1], szEndConv[MAXALPHATIMEDATE+1];
	TIMEDATE	tdStart, tdEnd;
	char far	*pStartTime, *pEndTime;
	LONG		timeDiff, dayDiff;

	/* get the start and end dates from the user */
	if (argc == 3)
	{
		strcpy(szStartTime, argv[1]);
		strcpy(szEndTime, argv[2]);
	}  else  {
		printf("Enter a start date: ");
		gets(szStartTime);
		printf("Enter an end date: ");
		gets(szEndTime);
	}

	/* convert them to TIMEDATE format */
	pStartTime = szStartTime;		/* annoying conversion... */
	nError = ConvertTextToTIMEDATE(NULL, NULL, &pStartTime, MAXALPHATIMEDATE, &tdStart);
	if (nError != NOERROR)
	{
		printf("Error converting start time %s\n", szStartTime);
		return (nError);
	}

	pEndTime = szEndTime;		/* annoying conversion... */
	nError = ConvertTextToTIMEDATE(NULL, NULL, &pEndTime, MAXALPHATIMEDATE, &tdEnd);
	if (nError != NOERROR)
	{
		printf("Error converting end time %s\n", szEndTime);
		return (nError);
	}

	/* show the user how the times look once they've been converted */
	GetTDString(&tdStart, szStartConv);
	GetTDString(&tdEnd, szEndConv);
	printf("\nConverted start time: %s\nConverted end time: %s\n", szStartConv, szEndConv);

	/* and get the difference in time */
	timeDiff = TimeDateDifference(&tdEnd, &tdStart);
	dayDiff = TimeExtractJulianDate(&tdEnd) - TimeExtractJulianDate(&tdStart);

	printf("\nThe TimeDateDifference is %d seconds (%d days)\n", timeDiff, timeDiff / (24*60*60));
	printf("The Julian Date difference is %d days\n", dayDiff);

	return NOERROR;
}


void GetTDString( TIMEDATE * ptdModified, char * szTimedate )
{
	WORD	wLen;

	ConvertTIMEDATEToText( NULL, NULL, 
				ptdModified, 
				szTimedate, 
				MAXALPHATIMEDATE,
				&wLen );

	szTimedate[wLen] = '\0';
	return;
}

